	/*
		Simple DirectX 11

		File:		Class_Shader.cpp
		Version:	0.1
		Author:		Nero

		Referenzen:
		http://msdn.microsoft.com/en-us/library/windows/desktop/ee663274%28v=vs.85%29.aspx
	*/


	#include <Class_Shader.h>
	
	sdx_Shader::sdx_Shader(void)
	{
	}
	sdx_Shader::~sdx_Shader(void)
	{
	}

	DWORD* sdx_Shader::WChartoChar(TCHAR* String)
	{
		DWORD sLen = wcslen(String);
		DWORD * newChar = PB_AllocateMemory(sLen + 1);
		PB_FillMemory(newChar, sLen+1);

		WideCharToMultiByte(CP_ACP, 0, String, sLen + 1, (char*) newChar, sLen + 1, NULL, NULL);

		
		return newChar;
	}

	HRESULT sdx_Shader::sdx_Shader_CompileShaderFromMemory(TCHAR* FileName, TCHAR* EntryPoint, TCHAR* ShaderModel, TCHAR* ShaderPtr, DWORD DataLen)
	{
		ID3DBlob * ErrorBlob;

		ShaderList * tmpBlop = (ShaderList*) PB_AllocateMemory(sizeof(ShaderList));
		
		char* tmpFileName		=	(char*) this->WChartoChar(FileName);
		char* tmpEntryPoint		=	(char*) this->WChartoChar(EntryPoint);
		char* tmpShaderModel	=	(char*) this->WChartoChar(ShaderModel);
		char* tmpShaderPtr		=	(char*) this->WChartoChar(ShaderPtr);

		tmpBlop->FileName   = FileName;
		tmpBlop->EntryPoint = EntryPoint;
		tmpBlop->Version    = ShaderModel;

		this->sdx_Shader_Error = D3DX11CompileFromMemory(
														 tmpShaderPtr,
														 DataLen,
														 tmpFileName,
														 NULL,
														 NULL,
														 tmpEntryPoint,
														 tmpShaderModel,
														 D3DCOMPILE_ENABLE_STRICTNESS,
														 0,
														 NULL,
														 &tmpBlop->Shader,
				    								 	 &ErrorBlob,
														 NULL
													    );
		
		if(FAILED(this->sdx_Shader_Error)) return this->sdx_Shader_Error;
		
		this->sdx_Shader_CompiledShaderList.push_back(tmpBlop);
		
		PB_FreeMemory((DWORD*) tmpBlop);

		if(ErrorBlob) ErrorBlob->Release();

		return S_OK;
	}