	/*
		Simple DirectX 11

		File:		Class_ExamineAdapters.h
		Version:	0.2
		Author:		Nero

		Referenzen:
		http://www.spieleprogrammierer.de/27-tutorials/13263-direct3d11-settings-dialog-teil-1-enumerieren/
		http://www.directxtutorial.com/Tutorial11/tutorials.aspx
		http://www.rastertek.com/tutdx11.html	

	*/

	#include <SimpleDX11.h>

	// sdx_E_Adapters Constructor
	SimpleDX11::SimpleDX11()
	{
		this->sdxError = S_OK;

		this->sdxD3D = new sdx_Direct3D();
		if (!this->sdxD3D) this->sdxError = E_SDX_D3D;

		this->sdxShader = new sdx_Shader();;
		if (!this->sdxShader) this->sdxError = E_SDX_SHADER;

		this->sdxError	= this->sdxD3D->sdx_D3D_Error;
	}

	// sdx_E_Adapters Destructor
	SimpleDX11::~SimpleDX11()
	{
		delete this->sdxD3D;
		delete this->sdxShader;
	}

	// Alle Adapter untersuchen und auflisten
	HRESULT SimpleDX11::sdxExamineAdapters(DWORD * outPtr)
	{
		sdx_E_Adapters * EAdapters = new sdx_E_Adapters();

		if (EAdapters->sdx_E_Error == E_EXA_FACTORY)
		{
			delete EAdapters;		
			return E_EXA_FACTORY;
		}

		if (FAILED(EAdapters->ExamineAdapters(outPtr))) 
		{
			delete EAdapters;		
			return E_EXA_ADAPTERS;
		}
		
		delete EAdapters;
		
		return S_OK;
	}

	HRESULT SimpleDX11::sdxInitScreen(D3DAdapterSettings * Settings)
	{
		return this->sdxD3D->sdx_D3D_InitScreen(Settings);
	}

	void SimpleDX11::sdxFreeScreen(void)
	{
		return this->sdxD3D->sdx_D3D_FreeScreen();
	}

	void SimpleDX11::sdxClearScreen(DWORD Color)
	{
		return this->sdxD3D->sdx_D3D_ClearScreen(Color);
	}
	void SimpleDX11::sdxFlipBuffers(void)
	{
		return this->sdxD3D->sdx_D3D_FlipBuffers();
	}

	HRESULT SimpleDX11::sdxCompileShaderFromMemory(TCHAR* FileName, TCHAR* EntryPoint, TCHAR* ShaderModel, TCHAR* ShaderPtr, DWORD DataLen)
	{
		return this->sdxShader->sdx_Shader_CompileShaderFromMemory(FileName, EntryPoint, ShaderModel, ShaderPtr, DataLen);
	}

	DWORD* SimpleDX11::sdxWChartoChar(TCHAR* wStr)
	{
		return this->sdxShader->WChartoChar(wStr);
	}